CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C       A MODEL FOR PREDICTING STAR COUNTS IN THE INFRARED            C
C                   Roberto Ortiz & Jacques Lepine                    C
C                           September  2002                           C
C                                                                     C
C  This version computes starcounts as function of limiting magnitude C
C  for a fixed direction. Files hess7.dat and galaxy.dat are needed.  C
C  The Galaxy is described by two disks, four spiral arms,            C
C  halo, and a bar.                                                   C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      IMPLICIT DOUBLE PRECISION (d)
      IMPLICIT REAL*4 (a-c,e-h,o-z)
      IMPLICIT INTEGER*4 (i-n)
      CHARACTER BAND*2,OBJ*8,DCLOUD*2,REPORT*2
      logical passou,final
      DIMENSION ALAM(1:10),VAR(1:10),ABMAG(1:10),POP(1:6),TOTPOP(0:6)
      DATA dPI /3.14159265359/
      DATA dDRHO /10./
C Ratios of IR extinction to visual extinction for B,V,R,I,J,H,K,L,12,25
      DATA (ALAM(I),I=1,10) /1.32,1.00,0.74,0.53,0.26,0.15,0.09,0.05,
     1 0.03,0.015/
C Amplitude of variability of Miras
      DATA (VAR(I),I=1,10) /4.0,3.0,1.6,1.25,1.04,0.87,0.72,0.58,
     1 0.7,0.7/
C Luminosity classes: 0=AGB; 1=dwarfs; 2=giants; 3=supergiants
      OPEN(10,FILE='sortie.1',STATUS='NEW')
      do i=1,6
       pop(i)=0.
       totpop(i)=0.
      enddo
      TOTAL=0.
      TOTAL0=0.
      DTOT=0.
C If in your system the terminal is not 5 then you must correct the
C following 
5     FORMAT(A2)
      WRITE(*,*)'BAND? (B,V,R,I,J,H,K,L,12,25)'
      READ(*,5)  BAND
      WRITE(*,*)'Longitude, latitude in degrees'
      READ(*,*)  dLDEG,dBDEG
      WRITE(*,*)'Inicial lim. mag., final lim.mag., step'
      READ(*,*)  AMAGIN,AMAGFIN,PASMAG
      WRITE(*,*)'The model permits you to include a particular dark',
     1 ' cloud, at a distance to be chosen.'
      WRITE(*,*)'Do you want to include it ?(Y/N)'
      READ(*,5) DCLOUD
      if ((DCLOUD.EQ.'Y ').or.(DCLOUD.EQ.'y ')) THEN
        WRITE(*,*)'Distance to the cloud (in pc), visual extinction'
        READ(*,*)  DIST,VEXTI
      else
        DIST=0.
        VEXTI=0.
      endif
      WRITE(*,*)'Do you want a short (S) or a detailed (D) report?'
      READ(*,5) REPORT
      if(REPORT.EQ.'s ') REPORT='S '
      if(REPORT.EQ.'d ') REPORT='D '
C 
      IF (BAND.EQ.'B ') NBD=1
      IF (BAND.EQ.'V ') NBD=2
      IF (BAND.EQ.'R ') NBD=3
      IF (BAND.EQ.'I ') NBD=4
      IF (BAND.EQ.'J ') NBD=5
      IF (BAND.EQ.'H ') NBD=6
      IF (BAND.EQ.'K ') NBD=7
      IF (BAND.EQ.'L ') NBD=8
      IF (BAND.EQ.'12') NBD=9
      IF (BAND.EQ.'25') NBD=10
C
      OPEN(2,FILE='galaxy.dat',STATUS='OLD')
      READ(2,*) dR0
      READ(2,*) dALFAY
      READ(2,*) dALFAO
      READ(2,*) dBETAY
      READ(2,*) dBETAO
      READ(2,*) dRE
      READ(2,*) BULTD
      READ(2,*) APLAT
      READ(2,*) CONTRST
      READ(2,*) CAV   
      READ(2,*) DISP
      READ(2,*) dx0,dy0,dz0
      READ(2,*) dalfa
      READ(2,*) bardisk
      CLOSE(2)
C---------------------------------------------------------------------
      WRITE(10,*)'Photometric band: ',BAND
      WRITE(10,*)'Galactic coordinates'
      WRITE(10,280) dLDEG,dBDEG
      WRITE(10,*)' Step  R0   Alfayoung Alfaold Betayoung Betaold    Re'
      write(10,300) dDRHO,dR0,dALFAY,dALFAO,dBETAY,dBETAO,dRE
      write(10,*) ' ' 
      write(10,*)' Aplat Contrast  Ext.Coeff. Displ.Sun'
      write(10,305) APLAT,CONTRST,CAV,disp
      write(10,*)' ' 
      WRITE(10,*)'Data relative to the dark cloud:'
      WRITE(10,*)'Distance, Visual Extinction'
      WRITE(10,310) DIST,VEXTI
      write(10,*)' '
      if(REPORT.EQ.'S ') 
     1 WRITE(10,*)'Limit Mag. log(N)     Mag.       log(A)'
280   FORMAT(2(2X,F6.2))
300   FORMAT(2x,f4.0,1x,6(f5.0,4x))
305   format(2x,f4.2,2x,f6.2,4x,e8.2,4x,f5.1)
310   FORMAT(F5.0,4X,F5.1)
C---------------------------------------------------------------------
      SCALE=(1.0E-06*(dPI/180.)**2)/3.
      HNORM=dR0*((dR0+dRE)**3)*BULTD
      if(dL.lt.0.) dL=360.+dL
      dL=dLDEG*dPI/180.
      dB=dBDEG*dPI/180.
      dalfa=dalfa*dPI/180.
      VARIA=VAR(NBD)
      ALMT=AMAGIN
C-----Integracao ao longo da linha de visada---------------------------
1000  FORMAT(A8,1X,F3.1,1X,I1,1X,F10.4,1X,F3.1,4X,10(F6.2),3(1X,F4.2))
1100  OPEN(1,FILE='hess7.dat',STATUS='OLD')
      TOTAL=0.
      do I=1,6
       TOTPOP(I)=0.
      enddo
      if(REPORT.EQ.'D ') WRITE(10,*)'Object Lum. Mag.  Counts   spiral
     1   young      old     carbon   spheroid    bar'
1200  READ(1,1000,end=2400) OBJ,SPTY,LUM,DENS,SIGM,(ABMAG(I),I=1,10),
     1 FRACSPI,FRACYOUNG,FRACOLD
      ABSM=ABMAG(NBD)
      CONT=0.
      TOTPOP(0)=0.
      do I=1,6
       POP(I)=0.
      enddo
      dR=dR0
      dRHO=0.
      dRPREV=dR
      dR2PREV=dR
      VOL=0.
      passou=.false.
      final=.false.
      AV=0.
C Start of loop over distance --------------------------------------
C
2100  CONTINUE
c  Geometry:
      dR2PREV=dRPREV
      dRPREV=dR
      dRHO=dRHO+dDRHO
      dZ=dRHO*dsin(dB)+disp
      dR=(dR0**2)+(dRHO**2)*(dcos(dB)**2)-
     1  (2*dRHO*dR0*dcos(dL)*dcos(dB))
      dR=dsqrt(dR)
C     VOL1 keeps the previous value of VOL
      VOL1=VOL
      VOL=(dRHO**3)*SCALE
      DVOL=VOL-VOL1
      dZETA=dsqrt(((dZ/APLAT)**2)+(dR**2))
      DISMOD=5.*dlog10(dRHO)-5.
C--------------------------------------------------------------------
C Vou introduzir uma parede de extincao para simular uma Nuvem Escura
      IF((dRHO.GT.DIST).AND.(.not.passou)) THEN
        AV=AV+VEXTI
        passou=.true.
      ENDIF
C--------------------------------------------------------------------
      AV=AV+(dDRHO*dEXTINC(dR,dZ,dR0,CAV))
c
c      write(10,*)'-----------------------------------------------'
c      write(10,*)'RHO = ',dRHO
c      write(10,*)'DVOL = ',DVOL
c      write(10,*)'R = ',dR,' Z = ',dZ
c      write(10,*) OBJ,LUM
c      write(10,*)'m-M = ',DISMOD,' Av = ',AV
C DEFINITIONS: 
C FRAVAR(LCLASS,SPTY) is the fraction of the stars which present
C variability and consequently a larger range of magnitudes;
C SIGM is the range of magnitude
C FRCONT(APMAG,ALMT,SIGM) is the fraction of stars which are to be counted
C in a given element of volume
c 
      APMAG=ABSM+DISMOD+(AV*ALAM(NBD))
C     Fraction to be counted if variability:
      FVAR=FRAVAR(LUM,SPTY)*FRCONT(APMAG,ALMT,VARIA)
C     Fraction to be counted if no variability:
      FNOVAR=(1.-FRAVAR(LUM,SPTY))*FRCONT(APMAG,ALMT,SIGM)
      CONTFRA=FVAR+FNOVAR 
      DYOUNG=dYOUNGDISK(dR0,dALFAY,dBETAY,dR,dZ)*FRACYOUNG
      DOLD=dOLDDISK(dR0,dALFAO,dBETAO,dR,dZ)*FRACOLD
      DC=0.
      IF(SPTY.EQ.8.)  DC=dCDISK(dR,dR0,dZ)
      DSPHE=0.
      DBAR=0.
      if((SPTY.GE.4.0).AND.(SPTY.LT.8.0)) then
       DSPHE=dSPHERE(dRE,dZETA)*HNORM
       DBAR=dBARRA(dL,dB,dR,dZ,dR0,dRHO,dx0,dy0,dz0,dalfa)*bardisk
      endif
      DSPI=0.
      IF((LUM.EQ.3).OR.((SPTY.GT.0.).AND.(SPTY.LT.2.))) 
     1 DSPI=dSPIRAL(dL,dB,dR,dZ,dR0,dRHO,dALFAY,dBETAY,CONTRST)
     2 *FRACSPI
c      DCONT=DBAR*DENS*DVOL*CONTFRA
      DCONT=(DYOUNG+DOLD+DC+DSPHE+DBAR+DSPI)*DENS*DVOL*CONTFRA
       POP(1)=POP(1)+(DENS*DVOL*CONTFRA*DSPI)
       POP(2)=POP(2)+(DENS*DVOL*CONTFRA*DYOUNG)
       POP(3)=POP(3)+(DENS*DVOL*CONTFRA*DOLD)
       POP(4)=POP(4)+(DENS*DVOL*CONTFRA*DC)
       POP(5)=POP(5)+(DENS*DVOL*CONTFRA*DSPHE)
       POP(6)=POP(6)+(DENS*DVOL*CONTFRA*DBAR)
      CONT=CONT+DCONT
c
c      write(10,*)'DENS   = ',DENS
c      write(10,*)'CONTFRA= ',CONTFRA
c      write(10,*)'DYOUNG = ',DYOUNG
c      write(10,*)'DOLD   = ',DOLD
c      write(10,*)'DC     = ',DC
c      write(10,*)'DSPHE  = ',DSPHE
c      write(10,*)'DSPI   = ',DSPI
c      write(10,*)'DCONT  = ',DCONT
      IF((dR.GT.30000.).OR.(CONTFRA.EQ.0.)) final=.true.
      IF(.not.final) GOTO 2100
      if(REPORT.EQ.'D ') 
     1 WRITE(10,2300) OBJ,LUM,ABSM,CONT,(POP(I),I=1,6)
2300  FORMAT(A8,1X,I1,1X,F5.1,7(1X,E9.3))
      do I=1,6
       TOTPOP(I)=TOTPOP(I)+POP(I)
      enddo
       TOTAL=TOTAL+CONT
       TOTPOP(0)=TOTAL
       IF(final) GOTO 1200
C End of loop over distance ---------------------------------------
2400  CLOSE(1)
      if(REPORT.eq.'D ') then
       OBJ='Total = '
       write(10,2450) OBJ,(TOTPOP(I),I=0,6)
      endif
2450  format(A8,8X,7(1X,E9.3))
      if(TOTAL0.ne.0.) DTOT=TOTAL-TOTAL0
      TOTAL0=TOTAL
      DLMT=ALMT-(PASMAG/2.)
      if (REPORT.EQ.'D ')
     1 WRITE(10,*)'Limit Mag. log(N)     Mag.       log(A)'
      if (DTOT.eq.0.) then
       TOTAL=log10(TOTAL)
       write(10,2500) ALMT,TOTAL
      else
       TOTAL=log10(TOTAL)
       DTOT =log10(DTOT)
       write(10,2550) ALMT,TOTAL,DLMT,DTOT
      endif
      if (REPORT.EQ.'D ') 
     1 WRITE(10,*)'------------------------------------------'
2500  FORMAT(F5.2,6X,F6.2)
2550  FORMAT(2(F5.2,6X,F6.2,5X))
      IF (ALMT.LT.AMAGFIN) THEN
        ALMT=ALMT+PASMAG
        GO TO 1100
      END IF
      CLOSE(10)
      STOP
      END
C----------------------------------------------------------------------
C
C CALCULATION OF FRACTION OF STARS OBSERVABLE
C SIGM IS HALF DISPERSION RANGE OF MAGNITUDE OR VARIABILITY RANGE
C
      REAL FUNCTION FRCONT*4(APAR,ALIM,SIGM)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      FRCONT=0.
      APAR1=APAR+SIGM
      APAR2=APAR-SIGM
      IF(APAR1.LE.ALIM) THEN
         FRCONT=1.
         RETURN
      END IF
      IF(APAR2.GE.ALIM) THEN
         FRCONT=0.
         RETURN
      END IF
      FRCONT=(ALIM-APAR+SIGM)/(2.*SIGM)
      RETURN
      END
C---------------------------------------------------------------------
      REAL FUNCTION FRAVAR*4(LUM,SPTY)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      FRAVAR=0.
      if(LUM.eq.0) then
         FRAVAR=0.90
         return    
      endif
      IF(LUM.EQ.1) RETURN
      IF(LUM.EQ.2) THEN
         if (SPTY.GT.6.3) then
          FRAVAR=0.36
          return
         else
          FRAVAR=0.
          RETURN
         endif
      END IF
      IF(LUM.EQ.3) RETURN
      RETURN
      END
C----------------------------------------------------------------------
      double precision FUNCTION dYOUNGDISK(dR0,dALFAY,dBETAY,dR,dZ)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dYOUNGDISK=0.
c      dverty=200.*dexp(0.4*(dR-dR0)/dR0)
      dverty=100.*dexp(0.4*(dR-dR0)/dR0)
      dYOUNGDISK=dexp(dBETAY*(1./dR0-1./dR)+(dR0-dR)/dALFAY)
     1 *dexp(-dabs(dZ/dverty))
c     1 *dcosh(dZ/dverty)**-2.
      RETURN   
      END
C----------------------------------------------------------------------
      double precision FUNCTION dOLDDISK(dR0,dALFAO,dBETAO,dR,dZ)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dOLDDISK=0.
c      dverto=800.*dexp(0.4*(dR-dR0)/dR0)
      dverto=400.*dexp(0.4*(dR-dR0)/dR0)
      dOLDDISK=dexp(dBETAO*(1./dR0-1./dR)+(dR0-dR)/dALFAO)
     1 *dexp(-dabs(dZ/dverto))
c     1 *dcosh(dZ/dverto)**-2.
      RETURN
      END
C-----------------------------------------------------------------------
      double precision FUNCTION dCDISK(dR,dR0,dZ)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dCDISK=0.
c      IF(dR.LT.(dR0*1.5)) dCDISK=dcosh(dZ/400.)**-2.
      IF(dR.LT.(dR0*1.5)) dCDISK=dexp(-dabs(dZ/200.))
      RETURN
      END
C-----------------------------------------------------------------------
      double precision FUNCTION dSPIRAL(dL,dB,dR,dZ,dR0,dRHO,dALFAY,
     1 dBETAY,CONTRST)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      DIMENSION dARM(8)
      dPI=3.14159265359
      ANGI=14.0*dPI/180.
      THET0=0.
      dSIGMAR=150.
      dSPIRAL=0.
      IF((dabs(dZ)).gt.150.) RETURN
      dSPIRAL=dexp(dBETAY*(1./dR0-1./dR)+(dR0-dR)/dALFAY)
     1 *dexp(dabs(dZ/50.))**-2
c     1 *dcosh(dZ/100.)**-2
C This is the inter-arm background of OB stars and supergiants
      IF(dR.gt.(dR0*1.28)) RETURN
      dRI=2100.*dR0/7900.
      dRLIM=2100.*dR0/7900.
      IF(dR.LT.dRLIM) RETURN
      FTAN=tan(ANGI)
C     SIGMAR is the width of spiral arms in the plane
C     CONTRST is the ratio of density at maximum of spiral arms
C     to inter-arm density
      THETA=dacos((dR0**2+dR**2-((dRHO*dcos(dB))**2))/(2*dR*dR0))
      if (dL.lt.dPI) THETA=2.*dPI-THETA
      F2=EXP(2.*dPI*FTAN)
        DO 3000 K=1,4   
        dARM(K)=dRI*dexp((THETA-THET0-((K-1)*(dPI/2.)))*FTAN)
C  ARM2 takes into account that arms continue for Theta > 360 degrees
        dARM(K+4)=dARM(K)*F2
3000    CONTINUE
C  Introduzido um contraste variavel:
        DO 3100 K=1,8
        IF ((dabs(dR-dARM(K))).LT.(3.*dSIGMAR)) THEN
        CONTRSV=CONTRST*(dabs(dR-dR0)*2./dR0)
        dSPIRAL=dSPIRAL*   
     1   (1.+CONTRSV*dexp(-0.5*((dR-dARM(K))/dSIGMAR)**2))
        RETURN
        END IF
3100    CONTINUE
      RETURN
      END
C----------------------------------------------------------------------
      double precision FUNCTION dSPHERE(dRE,dZETA)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dSPHERE=0.
      dSPHERE=(dZETA*((dZETA+dRE)**3.))**-1.
      RETURN
      END
c----------------------------------------------------------------------
      double precision FUNCTION dBARRA(dL,dB,dR,dZ,dR0,dRHO,dx0,dy0,dz0,
     1 dalfa)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dBARRA=0.
      distc=dsqrt(dr**2+dz**2)
      if(distc.lt.2400.) then
       dx1=-drho*dcos(db)*dsin(dl)
       dy1=drho*dcos(db)*dcos(dl)-dr0
       dx2=dx1*dcos(dalfa)+dy1*dsin(dalfa)
       dy2=-dx1*dsin(dalfa)+dy1*dcos(dalfa)
       dz2=dz
       drs=(((dx2/dx0)**2+(dy2/dy0)**2)**2+(dz2/dz0)**4)**0.25
       dBARRA=dexp(-0.5*(drs*drs))
      endif
      return
      end
C----------------------------------------------------------------------
      double precision FUNCTION dEXTINC(dR,dZ,dR0,CAV)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dEXTINC=0.
      IF((dabs(dZ)).gt.500.) RETURN
      dRK=0.001*dR*7900./dR0
      BETACO=36.*dexp(0.08*dRK*(10000./dR0))
      BETAHI=BETACO*1.8
      IF (dRK.LT.1.2) THEN
        ZMET=9.6
      ELSE
        ZMET=(dR0/dR)**1.2
      END IF
      ACO=0.89+(-1.51368*dRK)+(1.03631*(dRK**2))+
     1    (-0.260284*(dRK**3))+(0.0299764*(dRK**4))+
     2    (-0.0016276*(dRK**5))+(3.39087E-5*(dRK**6))
      IF (dRK.GT.12.0) ACO=0.03
      IF (dRK.LT.1.2) ACO=(10.0-8.17*dRK)
      AHI=0.78+(-1.22071*dRK)+(0.721961*(dRK**2))+(-0.18347*(dRK**3))+
     1 (0.0231594*(dRK**4))+(-0.00142902*(dRK**5))+(3.42778E-5*(dRK**6))
      IF (dRK.LT.0.50) AHI=0.50
      IF (dRK.GT.12.0) AHI=0.05
      dZC=0.
      IF ((dRK.GE.2.5).AND.(dRK.LT.4.0)) dZC=-15.0
      IF ((dRK.GE.4.0).AND.(dRK.LT.6.5)) dZC=-30.0
      IF ((dRK.GE.6.5).AND.(dRK.LT.9.5)) dZC=-10.0
      A=(AHI*ZMET*dexp(-0.5*(((dZ-dZC)/BETAHI)**2)))+
     1  (2*ACO*dexp(-0.5*(((dZ-dZC)/BETACO)**2)))
      dEXTINC=A*3.086E18*CAV*(7900./dR0)
      RETURN
      END
