CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C       A MODEL FOR PREDICTING STAR COUNTS IN THE INFRARED            C
C                   Roberto Ortiz & Jacques Lepine                    C
C                           September  2002                           C
C                                                                     C
C  This version computes starcounts as function of limiting magnitude C
C  for a fixed direction. Files hess8.dat and galaxy.dat are needed.  C
C  The Galaxy is described by two disks, four spiral arms,            C
C  a spheroid (representing the bulge and the halo), and a bar.       C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      IMPLICIT DOUBLE PRECISION (d)
      IMPLICIT REAL*4 (a-c,e-h,o-z)
      IMPLICIT INTEGER*4 (i-n)
      CHARACTER OBJ*8,DCLOUD*2,TEXTO*8,MENOS*1
      LOGICAL prima,passou,final
      DIMENSION ALAM(1:11),VAR(1:11),ABMAG(1:11),BIN(-5:50),
     1 CONT(-5:50),CONT1(-5:50)
      DATA dPI /3.14159265359/
      DATA dDRHO /10./
C Ratios of IR extinction to visual extinction for I,J,H,K,LW2,LW3,LW5,
c LW6,LW7,LW9,LW10.
      data (ALAM(i),i=1,11) /0.58,0.29,0.15,0.09,0.023,0.020,0.020,
     1 0.023,0.020,0.016,0.03/
C Amplitude of variability of Miras
      DATA (VAR(I),I=1,11) /1.25,1.04,0.87,0.72,1.0,1.0,1.0,
     1 1.0,1.0,1.0,1.0/
C Luminosity classes: 0=AGB; 1=dwarfs; 2=giants; 3=supergiants
      OPEN(10,FILE='sortie.4',STATUS='NEW')
c
      do i=-5,50
       BIN(i)=I*0.2
       CONT(i)=0.
       CONT1(i)=0.
      enddo
      TOTAL=0.
      TOTAL1=0.
      prima=.true.
c
C If in your system the terminal is not 5 then you must correct the
C following 
5     FORMAT(A2)
      WRITE(*,*)'Bands available: ' 
       write(*,*)'I   =  1'
       write(*,*)'J   =  2'
       write(*,*)'H   =  3'
       write(*,*)'K   =  4'
       write(*,*)'LW2 =  5'
       write(*,*)'LW3 =  6'
       write(*,*)'LW5 =  7'
       write(*,*)'LW6 =  8'
       write(*,*)'LW7 =  9'
       write(*,*)'LW9 = 10'
       write(*,*)'LW10= 11'
       write(*,*)'Enter the numbers of the colors:',
     1 ' "blue" band, "red" band:'
      READ(5,*)  NBD1,NBD2
      write(*,*)'Enter band to be limited in magnitude'
      read(5,*) NBD3
      WRITE(*,*)'Range of magnitudes: minimum, maximum'
      READ(*,*)  AMAGIN,AMAGFIN
      WRITE(*,*)'Longitude, latitude in degrees'
      READ(*,*)  dLDEG,dBDEG
      WRITE(*,*)'The model permits you to include a particular dark',
     1 ' cloud, at a distance to be chosen.'
      WRITE(*,*)'Do you want to include it ?(y/n)'
      READ(5,5) ANSWER
      IF ((DCLOUD.EQ.'Y ').or.(DCLOUD.EQ.'y ')) THEN
        WRITE(*,*)'Distance to the cloud (in pc), visual extinction'
        READ(*,*)  DIST,VEXTI
      else
        DIST=0.
        VEXTI=0.
      ENDIF
c
      OPEN(2,FILE='galaxy.dat',STATUS='OLD')
      READ(2,*) dR0
      READ(2,*) dALFAY
      READ(2,*) dALFAO
      READ(2,*) dBETAY
      READ(2,*) dBETAO
      READ(2,*) dRE
      READ(2,*) BULTD
      READ(2,*) APLAT
      READ(2,*) CONTRST
      READ(2,*) CAV
      READ(2,*) DISP
      READ(2,*) dx0,dy0,dz0
      READ(2,*) dalfa
      READ(2,*) bardisk
      CLOSE(2)
C---------------------------------------------------------------------
      MENOS='-'
      TEXTO='Color = '
      write(10,270) TEXTO,NBD1,MENOS,NBD2
      write(10,*)'Band to be limited in magnitude =',NBD3
      write(10,*)'Range in magnitude:',AMAGIN,'  ',MENOS,AMAGFIN
      WRITE(10,*)'Galactic coordinates'
      WRITE(10,280) dLDEG,dBDEG
      WRITE(10,*)' Step  R0   Alfayoung Alfaold Betayoung Betaold    Re'
      write(10,300) dDRHO,dR0,dALFAY,dALFAO,dBETAY,dBETAO,dRE
      write(10,*) ' '
      write(10,*)' Aplat Contrast  Ext.Coeff. Displ.Sun'
      write(10,305) APLAT,CONTRST,CAV,disp
      write(10,*)' '
      WRITE(10,*)'Data relative to the dark cloud:'
      WRITE(10,*)'Distance, Visual Extinction'
      WRITE(10,310) DIST,VEXTI
      WRITE(10,*)'Color   N'
270   format(A8,I2,1X,A1,I2)
280   FORMAT(2(2X,F6.2))
300   format(2x,f4.0,1x,6(f5.0,4x))
305   format(2x,f4.2,2x,f6.2,4x,e8.2,4x,f5.1)
310   FORMAT(F5.0,4X,F5.1)
C---------------------------------------------------------------------
      SCALE=(1.0E-06*(dPI/180.)**2)/3.
      HNORM=dR0*((dR0+dRE)**3)*BULTD
      if(dL.lt.0.) dL=360.+dL
      dL=dLDEG*dPI/180.
      dB=dBDEG*dPI/180.
      dalfa=dalfa*dPI/180.
      VARIA=VAR(NBD3)
      ALMT=AMAGIN
C-----Integracao ao longo da linha de visada---------------------------
1000  format(A8,1X,F3.1,1X,I1,1X,F10.4,2(1X,F3.1),11(F6.2),3(1X,F4.2))
1100  OPEN(1,FILE='hess8.dat',STATUS='OLD')
1200  read(1,1000,END=2400) OBJ,SPTY,LUM,DENS,SIGM,SIGC,
     1 (ABMAG(I),I=1,11),FRACSPI,FRACYOUNG,FRACOLD
      ABSM=ABMAG(NBD3)
      dR=dR0
      dRHO=0.   
      dRPREV=dR
      dR2PREV=dR
      VOL=0.
      passou=.false.
      final=.false.
      AV=0.
C Start of loop over distance --------------------------------------
C
2100  CONTINUE
c     Geometry:
      dR2PREV=dRPREV
      dRPREV=dR
      dRHO=dRHO+dDRHO
      dZ=dRHO*dsin(dB)+disp
      dR=(dR0**2)+(dRHO**2)*(dcos(dB)**2)-
     1  (2*dRHO*dR0*dcos(dL)*dcos(dB))
      dR=dsqrt(dR)
C     VOL1 keeps the previous value of VOL
      VOL1=VOL
      VOL=(dRHO**3)*SCALE
      DVOL=VOL-VOL1
      dZETA=dsqrt(((dZ/APLAT)**2)+(dR**2))
      DISMOD=5.*dlog10(dRHO)-5.
C--------------------------------------------------------------------
C Vou introduzir uma parede de extincao para simular uma Nuvem Escura
      IF((dRHO.GT.DIST).AND.(.not.passou)) THEN
        AV=AV+VEXTI
        passou=.true.
      ENDIF
C--------------------------------------------------------------------
      AV=AV+(dDRHO*dEXTINC(dR,dZ,dR0,CAV))
      REDD=AV*(ALAM(NBD1)-ALAM(NBD2))
      COLOR=ABMAG(NBD1)-ABMAG(NBD2)+REDD
c---------------------------------------------------------------------
C DEFINITIONS: 
C FRAVAR(LCLASS,SPTY) is the fraction of the stars which present
C variability and consequently a larger range of magnitudes;
C SIGM is the range of magnitude
C FRCONT(APMAG,ALMT,DELM) is the fraction of stars which are to be counted
C in a given element of volume
c 
       APMAG=ABSM+DISMOD+(AV*ALAM(NBD3))
C      Fraction to be counted if variability:
       FVAR=FRAVAR(LUM,SPTY)*FRCONT(APMAG,ALMT,VARIA)
C      Fraction to be counted if no variability:
       FNOVAR=(1.-FRAVAR(LUM,SPTY))*FRCONT(APMAG,ALMT,SIGM)
       CONTFRA=FVAR+FNOVAR
       DYOUNG=dYOUNGDISK(dR0,dALFAY,dBETAY,dR,dZ)*FRACYOUNG
       DOLD=dOLDDISK(dR0,dALFAO,dBETAO,dR,dZ)*FRACOLD
       DC=0.
       IF(SPTY.EQ.8.)  DC=dCDISK(dR,dR0,dZ)
       DSPHE=0.
       DBAR=0.
       if((SPTY.GE.4.0).AND.(SPTY.LT.8.0)) then
        DSPHE=dSPHERE(dRE,dZETA)*HNORM
        DBAR=dBARRA(dL,dB,dR,dZ,dR0,dRHO,dx0,dy0,dz0,dalfa)*bardisk
       endif
       DSPI=0.
       IF((LUM.EQ.3).OR.((SPTY.GT.0.).AND.(SPTY.LT.2.))) 
     1   DSPI=dSPIRAL(dL,dB,dR,dZ,dR0,dRHO,dALFAY,dBETAY,CONTRST)
     2    *FRACSPI
       DCONT=(DYOUNG+DOLD+DC+DSPHE+DBAR+DSPI)*DENS*DVOL*CONTFRA
c      DCONT=(DYOUNG+DOLD+DC+DSPHE+DSPI)*DENS*DVOL*CONTFRA
c---------------------------------------------------------------
c      Below, the counts are spread over the colour dispersion range:
       corinf=color-sigc
       corsup=color+sigc
       if(corsup.ge.0.) isup=int((corsup)/0.2+0.5)
       if(corsup.lt.0.) isup=int((corsup)/0.2-0.5)
       if(corinf.ge.0.) iinf=int((corinf)/0.2+0.5)
       if(corinf.lt.0.) iinf=int((corinf)/0.2-0.5)
c       write(*,*)'iinf= ',iinf,' isup= ',isup
       if(iinf.eq.isup) then
        if((isup.ge.-5).and.(isup.le.50)) CONT(isup)=CONT(isup)+DCONT
       else
       fbinsup=((((corsup+9.)/0.2)-0.5)-int(((corsup+9.)/0.2)-0.5))
       fbininf=1.-((((corinf+9.)/0.2)-0.5)-int(((corinf+9.)/0.2)-0.5))
       do i=iinf,isup
         if((i.gt.iinf).and.(i.lt.isup).and.(i.ge.-5).and.(i.le.50))
     1    CONT(i)=CONT(i)+DCONT*(0.2/(2*sigc))
         if((i.eq.isup).and.(i.ge.-5).and.(i.le.50))
     1    CONT(i)=CONT(i)+DCONT*(0.2/(2*sigc))*fbinsup
         if((i.eq.iinf).and.(i.ge.-5).and.(i.le.50))
     1    CONT(i)=CONT(i)+DCONT*(0.2/(2*sigc))*fbininf
        enddo
       endif
c---------------------------------------------------------------
       TOTAL=TOTAL+DCONT
       IF((dR.GT.30000.).OR.(CONTFRA.EQ.0.)) final=.true.
       IF(.not.final) GO TO 2100
       IF(final) GO TO 1200
c
C     End of loop over distance ---------------------------------------
2400  CLOSE(1)
      if(prima) then
       do I=-5,50
        CONT1(I)=CONT(I)
        CONT(I)=0.
       enddo
       TOTAL1=TOTAL
       TOTAL=0.
       ALMT=AMAGFIN
       prima=.false.
       goto 1100
      else
       do I=-5,50
        CONT(I)=CONT(I)-CONT1(I)
       enddo
       TOTAL=TOTAL-TOTAL1
      endif
      do I=-5,50
       WRITE(10,2500) BIN(I),CONT(I)
      enddo
2500  FORMAT(F4.1,1X,E9.3)
2550  format(A7,1X,E10.4)
      TEXTO='Total=  '
      write(10,2550) TEXTO,TOTAL
      CLOSE(10)
      STOP
      END
C----------------------------------------------------------------------
c     Calculation of the fraction of stars observable:
c     DELM is the half dispersion range of magnitude or variability range
c
      REAL FUNCTION FRCONT*4(APAR,ALIM,SIGM)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      FRCONT=0.
      APAR1=APAR+SIGM
      APAR2=APAR-SIGM
      IF(APAR1.LE.ALIM) THEN
         FRCONT=1.
         RETURN
      END IF
      IF(APAR2.GE.ALIM) THEN
         FRCONT=0.
         RETURN
      END IF
      FRCONT=(ALIM-APAR+SIGM)/(2.*SIGM)
      RETURN
      END
C---------------------------------------------------------------------
      REAL FUNCTION FRAVAR*4(LUM,SPTY)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      FRAVAR=0.
      if(LUM.eq.0) then
         FRAVAR=0.90
         return
      endif 
      IF(LUM.EQ.1) RETURN
      IF(LUM.EQ.2) THEN
         if (SPTY.GT.6.3) then
          FRAVAR=0.36
          return
         else
          FRAVAR=0.
          RETURN
         endif
      END IF
      IF(LUM.EQ.3) RETURN
      RETURN
      END
C----------------------------------------------------------------------
      double precision FUNCTION dYOUNGDISK(dR0,dALFAY,dBETAY,dR,dZ)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dYOUNGDISK=0.
c      dverty=200.*dexp(0.4*(dR-dR0)/dR0)
      dverty=100.*dexp(0.4*(dR-dR0)/dR0)
      dYOUNGDISK=dexp(dBETAY*(1./dR0-1./dR)+(dR0-dR)/dALFAY)
     1 *dexp(-dabs(dZ/dverty))
c     1 *dcosh(dZ/dverty)**-2.
      RETURN
      END
C----------------------------------------------------------------------
      double precision FUNCTION dOLDDISK(dR0,dALFAO,dBETAO,dR,dZ)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dOLDDISK=0.
c      dverto=800.*dexp(0.4*(dR-dR0)/dR0)
      dverto=400.*dexp(0.4*(dR-dR0)/dR0)
      dOLDDISK=dexp(dBETAO*(1./dR0-1./dR)+(dR0-dR)/dALFAO)
     1 *dexp(-dabs(dZ/dverto))
c     1 *dcosh(dZ/dverto)**-2.
      RETURN
      END
C----------------------------------------------------------------------
      double precision FUNCTION dCDISK(dR,dR0,dZ)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dCDISK=0.
      IF(dR.LT.(dR0*1.5)) dCDISK=dexp(-dabs(dZ/200.))
c      IF(dR.LT.(dR0*1.5)) dCDISK=dcosh(dZ/400.)**-2.
      RETURN
      END
C----------------------------------------------------------------------
      double precision FUNCTION dSPIRAL(dL,dB,dR,dZ,dR0,dRHO,dALFAY,
     1 dBETAY,CONTRST)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      DIMENSION dARM(8)  
      dPI=3.14159265359
      ANGI=14.0*dPI/180.
      THET0=0.
      dSIGMAR=150.
      dSPIRAL=0.
      IF((dabs(dZ)).gt.150.) RETURN
      dSPIRAL=dexp(dBETAY*(1./dR0-1./dR)+(dR0-dR)/dALFAY)
     1 *dexp(dabs(dZ/50.))**-2
c     1 *dcosh(dZ/100.)**-2
C This is the inter-arm background of OB stars and supergiants
      IF(dR.gt.(dR0*1.28)) RETURN
      dRI=2100.*dR0/7900.
      dRLIM=2100.*dR0/7900.
      IF(dR.LT.dRLIM) RETURN
      FTAN=tan(ANGI)
C     SIGMAR is the width of spiral arms in the plane
C     CONTRST is the ratio of density at maximum of spiral arms
C     to inter-arm density
      THETA=dacos((dR0**2+dR**2-((dRHO*dcos(dB))**2))/(2*dR*dR0))
      if (dL.lt.dPI) THETA=2.*dPI-THETA
      F2=EXP(2.*dPI*FTAN)
        DO 3000 K=1,4
        dARM(K)=dRI*dexp((THETA-THET0-((K-1)*(dPI/2.)))*FTAN)
C  ARM2 takes into account that arms continue for Theta > 360 degrees
        dARM(K+4)=dARM(K)*F2
3000    CONTINUE
C  Introduzido um contraste variavel:
        DO 3100 K=1,8
        IF ((dabs(dR-dARM(K))).LT.(3.*dSIGMAR)) THEN
        CONTRSV=CONTRST*(dabs(dR-dR0)*2./dR0)
        dSPIRAL=dSPIRAL*
     1   (1.+CONTRSV*dexp(-0.5*((dR-dARM(K))/dSIGMAR)**2))
        RETURN
        END IF
3100    CONTINUE
      RETURN
      END
C----------------------------------------------------------------------
      double precision FUNCTION dSPHERE(dRE,dZETA)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dSPHERE=0.
      dSPHERE=(dZETA*((dZETA+dRE)**3.))**-1.
      RETURN
      END
c----------------------------------------------------------------------
      double precision FUNCTION dBARRA(dL,dB,dR,dZ,dR0,dRHO,dx0,dy0,dz0,
     1 dalfa)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dBARRA=0.
      distc=dsqrt(dr**2+dz**2)
      if(distc.lt.2400.) then
       dx1=-drho*dcos(db)*dsin(dl)
       dy1=drho*dcos(db)*dcos(dl)-dr0
       dx2=dx1*dcos(dalfa)+dy1*dsin(dalfa)
       dy2=-dx1*dsin(dalfa)+dy1*dcos(dalfa)
       dz2=dz
       drs=(((dx2/dx0)**2+(dy2/dy0)**2)**2+(dz2/dz0)**4)**0.25
       dBARRA=dexp(-0.5*(drs*drs))
      endif
      return
      end
C----------------------------------------------------------------------
      double precision FUNCTION dEXTINC(dR,dZ,dR0,CAV)
      implicit double precision (d)
      implicit real (a-c,e-h,o-z)
      implicit integer (i-n)
      dEXTINC=0.
      IF((dabs(dZ)).gt.500.) RETURN
      dRK=0.001*dR*7900./dR0
      BETACO=36.*dexp(0.08*dRK*(10000./dR0))
      BETAHI=BETACO*1.8
      IF (dRK.LT.1.2) THEN
        ZMET=9.6
      ELSE
        ZMET=(dR0/dR)**1.2  
      END IF
      ACO=0.89+(-1.51368*dRK)+(1.03631*(dRK**2))+
     1    (-0.260284*(dRK**3))+(0.0299764*(dRK**4))+
     2    (-0.0016276*(dRK**5))+(3.39087E-5*(dRK**6))
      IF (dRK.GT.12.0) ACO=0.03
      IF (dRK.LT.1.2) ACO=(10.0-8.17*dRK)
      AHI=0.78+(-1.22071*dRK)+(0.721961*(dRK**2))+(-0.18347*(dRK**3))+
     1 (0.0231594*(dRK**4))+(-0.00142902*(dRK**5))+(3.42778E-5*(dRK**6))
      IF (dRK.LT.0.50) AHI=0.50
      IF (dRK.GT.12.0) AHI=0.05
      dZC=0.
      IF ((dRK.GE.2.5).AND.(dRK.LT.4.0)) dZC=-15.0
      IF ((dRK.GE.4.0).AND.(dRK.LT.6.5)) dZC=-30.0
      IF ((dRK.GE.6.5).AND.(dRK.LT.9.5)) dZC=-10.0
      A=(AHI*ZMET*dexp(-0.5*(((dZ-dZC)/BETAHI)**2)))+
     1  (2*ACO*dexp(-0.5*(((dZ-dZC)/BETACO)**2)))
      dEXTINC=A*3.086E18*CAV*(7900./dR0)
      RETURN
      END   
